# Les Relations

- Soient \\( A, B \\) deux ensembles
    - Le **Produit cartésien** noté \\( A \times B \\) est l'ensemble
        - \\( A \times B = \\{ (a,b) | a \in A \land b \in B\\} \\) 
            - Donc \\( A \times B \neq B \times A \\) 
    - Une **Relation Binaire** noté \\( R \\) est un sous-ensemble de
        - \\( A \times B \quad (R \subseteq A \times B)\\) 
        - Soient \\( a \in A \quad b \in B \\) 
            - On dit que a est en **Relation Binaire** ssi \\( (a,b) \in R \\) 
                - noté \\( aRb \\)
            - Quand \\( A = B \quad R \subseteq A \times A \\) on parle de relation sur \\( A \\) 

Par exemple:
1) \\( A = B = \mathbb{R} \quad R = \mathbb{R}^2 \subseteq \mathbb{R}^2 = \mathbb{R} \times \mathbb{R}  \\) 
2) \\( A = \\{2, 3 ,4\\} \quad B = \\{4, 6, 8\\} \quad R = \\{(a,b) \in A \times B | b = 2a\\} \\) 
3) \\( A = B = \\{ \text{ membre d'une famille } \\} \quad R = \\{ (a,b) | a \text{ est le père de }  B \\} \\) 
4) \\( A = B = \mathbb{R} \quad R_{\leq} = \\{ (a,b) \in \mathbb{R}^2 | a \leq b \\} \\) 

## Représentation des relations (finies)

Par exemple, pour:
\\[
    A = B = \\{ 1, 2, 3 \\} \quad R_{<} = \\{ (a,b) | a < b \\} 
\\]

1) Représentation Cartésienne
2) Représentation Patate
3) Représentation Matricielle

## Types de relations

- Soit \\( R \subseteq A \times A \\), On dit uqe R est 
    - **Réfléxive** ssi \\( \forall a \in  A \quad aRa \\) 
        - Que tout les éléments sont en relation avec eux même
    - **transitive** ssi \\( \forall a, b, c \in A \quad (aRb \land bRc) \implies aRc \\) 
        - Une forme de relation d'héritage.(eg: Si a est un ancetre de b et b est un ancetre de c alors a est un ancetre de c)
    - **Symétrique** ssi \\( \forall a,b \in A \quad aRb \implies bRa  \\) 
        - Toutes les relations sont toujours à double sens
    - **Anti-Symétrique** ssi \\( \forall a, b \in A \quad (aRb \land bRa) \implies a=b  \\) 
        - symètrique mais sans double flèches, seulement des flèches vers lui même

**Attention**, anti-symétrique n'est pas la négation de symétrique

## Relation inverse

- Soit \\( R \subseteq A \times B \\) 
    - La **Relation Inverse** notée \\( R^{-1} = \\{ (b, a) \in B \times A | aRb) \\}  \\)

La relation inverse retourne toute les fleches d'un graphe; Les relations sont inversées

On a prouvé que \\( R = R^{-1} \implies R \text{ est symétrique }  \\) 


